utility JuicedMeshScript "Juiced betafiles v1.0" width:160 height:466
(

	GroupBox grp1 "Juiced Beta File Importer" pos:[0,0] width:160 height:120
	checkbox chk1 "Index Objects" pos:[8,16] width:144 height:16 enabled:true checked:true
	checkbox chk13 "Clear Scene" pos:[8,40] width:128 height:15 checked:true
	checkbox chk14 "Delete Duplicate TriFaces" pos:[8,65] width:145 height:15 checked:true
	button btn2 "Import Beta" pos:[40,90] width:80 height:24
	GroupBox grp5 "About:" pos:[0,515] width:160 height:100
	label lbl3 "Juiced Mesh Import/Export Script Created By Martin_sw" pos:[8,535] width:144 height:32
	label lbl4 "Additional Scripting By Carl 'SxnnyB' Burns -Nov 2020" pos:[8,575] width:144 height:32
	
	--Original Juiced Import Script
	--Version 0.2
	--Made By: Martin_sw
	--
	--Juiced Import Script
	--Version 1.0 - 1.3
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced Xbox Import Script
	--Version 1.0
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced modding Discord:
	--https://discord.gg/pu2jdxR
	--
	--***Change log***
	--
	--v1.0
	--Changed version to 1.0 to reflect change of author
	--
	--Added selection box to write shadow data to last 44 bytes of file for main car body model
	--this enables under shadow and neons for car chassis
	--	
	--v1.1
	--Added cases for certain mesh types and Vertex data structures
	--After Market Rims and Exhaust in carmesh.dat now import properly
	--
	--v1.2
	--Added cases for various other certain mesh types and Vertex data structures
	--import should now be 99 percent compatible
	--
	--Clean up of script started, UI elements now ordered in appearence from top to bottom
	--Added check box on import for choosing to delete duplicate trifaces
	--
	--v1.3
	--Added Dropdown Dialog for MeshType per Mesh
	--
	--
	--Xbox import
	--v1.0
	--Adapted main import script for difference in xbox model files
	--
	--BetaFile import
	--v1.0
	--Adapted main import script for difference in Beta model files

	on btn2 pressed do
	(
	if chk13.checked == true then
	(
	delete objects
	)
	ClearListener()
	
	f = getOpenFileName \ 
	types:"Juiced bin(*.bin)|*.bin|Juiced d8m(*.d8m)|*.d8m|"
	f = fopen f "rb"
	
	if f != undefined then 	
	( 	
	--These 44bytes are mostly unknown functions. Assumed to behave like Shadow Section from Final Release
	for u = 1 to 11 do
	(
	Unknown = readfloat f
	format "Value: %\n" Unknown
	)
	
	------------------------------------------------------
	-- Read the total number of GeoIndexes in this file --
	------------------------------------------------------
	
	nTotalGeoIndexes = readlong f
	
	--need to read GeoIndex here
	--each vertex section is 36 bytes
	--Vertex Buffer?
	--
	--Vertex data structure
	--
	--Vertex
	--X = Readfloat f
	--Y = Readfloat f
	--Z = Readfloat f
	--Normal
	--NX = Readfloat f
	--NY = Readfloat f
	--NZ = Readfloat f
	--Unknown section 
	--Unknown = readfloat f
	--UV
	--UVW_U = readfloat f
	--UVW_V = readfloat f
	
	---------------------------------------------------
	-- Read the total number of indexes in this file --
	---------------------------------------------------
	nTotalIndexes = readlong f
	format "nTotalIndexes: %\n" nTotalIndexes
	Index_Array = #()
	for i = 1 to nTotalIndexes do
	(
	--Read the index into a array
	Index_Array[i] = readshort f
	)
	
	-----------------------------------------------
	-- Read the number uniqe meshes in this file --
	-----------------------------------------------
	nMeshes = readlong f
	
	--Mesh loop starts here	
	for i = 1 to nMeshes do
	(
	-- Read the name of this mesh/texture
	MeshName = readstring f
		
	-- These are fixed lenght strings so calcylate the,
	-- number of leftover bytes and read them.
	nBytesLeft = 32 - MeshName.count - 1
	
	for b = 1 to nBytesLeft do
	(
	tmpTrash = readbyte f
	)
	
	if chk1.checked == true then
	(
		StringToAdd = i as string
	
		if i < 10 then
		(
			StringToAdd = "0" + StringToAdd
		)
		StringToAdd = StringToAdd + ","
		append StringToAdd MeshName
		MeshName = StringToAdd
	)

		
	IndexStart = readlong f
	NumberOfIndexes = readlong f
	
	--Geoindex Start Offset for this mesh
	GeoIndexStart = readlong f
	--how many Vertex structures to read from GeoIndex
	NumberOfGeoIndexes = readlong f
	
	
	format "##### -=Mesh=- #####\n"
	format "Name: %\n" MeshName
	format "Index Start Offset: %\n" IndexStart
	format "Number of indexes: %\n" NumberOfIndexes
	format "Geo Index Start Offset: %\n" GeoIndexStart
	format "Number of Geo indexes: %\n" NumberOfGeoIndexes
	
	-- This indicates geometry type e.g. 0,trianglestrip or 1,trianglelist
	GeometryType = readlong f
	format "GeometryType: %\n" GeometryType
	
	-- See if there are any other values than 0 and 1 here, if so inform user to contact me
	if not GeometryType == 0 and not GeometryType == 1 then
	(
	MessageBox "Not Geometry Type 0 or 1, please contact Carl 'SxnnyB' Burns in Juiced Modding Discord"
	)
	
	-------------------------------------------------------------------
	-- Now we have come to the part of the file thats mostly unknown --
	-------------------------------------------------------------------
	
	--These 44bytes are mostly unknown functions. Assumed to behave like Deformation Section from Final Release
	for u = 1 to 11 do
	(
	Unknown = readfloat f
	format "Value: %\n" Unknown
	)

	format "##### -=EOM=- #####\n"
	
	---------------------------------------------------------------------------
	-- Now we have come to the point when 'Normally' we read the vertex data --
	---------------------------------------------------------------------------
	
	--This section is Stored differently In final Release Models 'Normally with number of bytes per vertex
	--Instead of storing vertex structure per mesh, it is stored as a single vertex index (GeoIndex)
	--!!!!This needs changed to work with GeoIndex structure!!!!
	
	vert_array = #() 
	Vector3D_Array = #() 
	Vertex2D_Array = #()
	
	for v = 1 to nVertices do
	(
	--Vertex
	X = Readfloat f
	Y = Readfloat f
	Z = Readfloat f
	
	vert = [X as float,Z as float,Y as float] as Point3
	vert_array[v] = vert
		
	--Normal
	NX = Readfloat f
	NY = Readfloat f
	NZ = Readfloat f
	Normal = [NX as float,NZ as float,NY as float] as Point3
	Vector3D_Array[v] = Normal
	
	--Unknown section 
	Unknown = readfloat f

	--UV
	UVW_U = readfloat f
	UVW_V = readfloat f
	
	UVW_W = 0.0 --Fake
	UVW_V = UVW_V - UVW_V - UVW_V
	UV = [UVW_U as float,UVW_V as float,UVW_W as float] as Point3
	Vertex2D_Array[v] = UV
	)
	
	--------------------------------------------------
	-- Now that we have read this mesh we must,     --
	-- destrip it to create a triangle list insted, --
	-- of a triangle strip.                         --
	--------------------------------------------------	
	
	if GeometryType == 0 then
	(
	Face_Array = #() 
	FaceUV_Array = #() 
	Flag = 0
	counter = 1
	for t = 1 to NumberOfIndexes - 2 do
	(
	AddTriangle = 1
	
	if Flag == 1 then
	(
	Flag = 0
	Index1 = Index_Array[IndexStart + t]
	Index2 = Index_Array[IndexStart + t + 1]
	Index3 = Index_Array[IndexStart + t + 2]
	)
	else
	(
	Flag = 1
	Index3 = Index_Array[IndexStart + t]
	Index2 = Index_Array[IndexStart + t + 1]
	Index1 = Index_Array[IndexStart + t + 2]
	)
	
	Index1 = Index1 + 1
	Index2 = Index2 + 1
	Index3 = Index3 + 1
			
	--Check if any of the indexes in the triangle is repeated if so don't add the triangle
	
	if chk14.checked == true then
	(
	if Index1 == Index2 then
	(
	AddTriangle = 0
	)
	if Index1 == Index3 then
	(
	AddTriangle = 0
	)
	if Index2 == Index1 then
	(
	AddTriangle = 0
	)
	if Index2 == Index3 then
	(
	AddTriangle = 0
	)
	if Index3 == Index1 then
	(
	AddTriangle = 0
	)
	if Index3 == Index2 then
	(
	AddTriangle = 0
	)
	
	if AddTriangle == 1 then
	(
	TriFace = [Index1,Index2,Index3] as Point3
	Face_Array[counter] = TriFace
	
	TriFace2 = [Index1,Index2,Index3] as Point3
	FaceUV_Array[counter] = TriFace2
	counter = counter + 1
	)
	)
			
	if not chk14.checked == true then
	(
	if AddTriangle == 1 then
	(
	TriFace = [Index1,Index2,Index3] as Point3
	Face_Array[counter] = TriFace
	
	TriFace2 = [Index1,Index2,Index3] as Point3
	FaceUV_Array[counter] = TriFace2
	counter = counter + 1
	)
	)
	)			
	)
	
	
	if GeometryType == 1 then
	(
	-- If the GeometryType indicates this mesh is made up by a trianglelist,
	-- insted of a trianglestrip then interpet it as a trianglelist.
	Face_Array = #() 
	FaceUV_Array = #()
	counter = 1
	for t = 1 to NumberOfIndexes / 3 do
	(
	Index3 = Index_Array[IndexStart + ((t - 1) * 3) + 1]
	Index2 = Index_Array[IndexStart + ((t - 1) * 3) + 2]
	Index1 = Index_Array[IndexStart + ((t - 1) * 3) + 3]

	
	Index1 = Index1 + 1
	Index2 = Index2 + 1
	Index3 = Index3 + 1
	
	TriFace = [Index1,Index2,Index3] as Point3
	Face_Array[counter] = TriFace
	
	TriFace2 = [Index1,Index2,Index3] as Point3
	FaceUV_Array[counter] = TriFace2
	counter = counter + 1
	)
	)
	
	
	tmpMesh = mesh name:MeshName vertices:vert_array faces:Face_Array-- normals:Vector3D_Array
	
	--Apply things like normals and uv mapping
	mesh_uv_vert = nVertices 
	
	setNumTVerts tmpMesh nVertices 
	buildTVFaces tmpMesh
	
	--Fill corrdinate list
	for uv = 1 to mesh_uv_vert do
	(
	--Fill the list whit uv corrds for usage later when attaching them to a face	
	setTVert tmpMesh uv Vertex2D_Array[uv]
	buildTVFaces tmpMesh
	)
	--Attatc to a face
	for uv = 1 to counter - 1 do
	(
	TriFace = FaceUV_Array[uv]	
	TriFace = TriFace as Point3
	setTVFace tmpMesh uv TriFace
	)	
	)
	fclose f
	)-- If to read
	)
